/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.system;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.system.boundary.AbstractSystemLogSearchParameters;
import de.ivu.elect.business.system.boundary.SystemLogChangeEvent;
import de.ivu.elect.business.system.boundary.SystemLogConversationStore;
import de.ivu.elect.business.system.boundary.SystemLogExtendedDAO;
import de.ivu.elect.business.system.boundary.SystemLogSearch;
import de.ivu.elect.business.system.boundary.SystemLogSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.system.entity.SystemLog;
import de.ivu.elect.business.system.entity.SystemLogMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractSystemLogSearchView.COMPONENT_NAME)
@View(viewId = AbstractSystemLogSearchView.VIEW_ID, useCase = UseCasePermission.SYSTEM_LOG_SEARCH)
public abstract class AbstractSystemLogSearchView extends AbstractElectSearchView<SystemLog> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "systemLogSearchView";
  
  public static final String VIEW_ID = "/system/system-log-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractSystemLogSearchView requestHandler;

  @Inject
  private transient SystemLogExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(SystemLogConversationStore.class)
  protected transient SystemLogConversationStore conversationStore;

  @Inject
  protected transient SystemLogSearch search;

  @Inject
  @ConversationGroup(AbstractSystemLogSearchParameters.class)
  protected transient SystemLogSearchParameters searchParameters;

  @Inject
  protected transient SystemLogMeta entityMeta;

  public AbstractSystemLogSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public SystemLog getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(SystemLog entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public SystemLogSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<SystemLog> getEagerLoadingCollector() {
    return EagerLoadingCollector.<SystemLog> create();
  }

  @Override
  public List<SystemLog> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<SystemLog> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onSystemLogChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) SystemLogChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractSystemLogSearchView {

    @View
    @Inject
    private transient Instance<AbstractSystemLogSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractSystemLogSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
